#<profile4xi profile = "31"/>
#<program4xi program = "walk2count4url.py">
#<abstract4xi abstract = "walks through HTML files of spefied directory and its subdirectories counting url referred as required"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "copy first output to input, then delete all html files in output - directories are not created for you"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'walk2count4url' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi      # from lutiprocessing4xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2debug
global count2skipped
global count2replaced
global count2total
global count2test4url
global count2ack4url
global count2nack4url
global count2app
global count2dev
global count2ssl


global file2output

global kb2search                             # knowledgebase for searching
global keys2search
global keys2replace
global keys2search
global kb2replace                            # knowledgebase for replacing
global keys2replace

global kb2url                                # knowledgebase for url
global key2url
global keys2url

global name2create
global path2temp4source  
global path2read4xi                          # path for input source targets
global path2write4xi                         # path for output source targets
global PickleKB4Xi
global profile2fetch                         # extension for files
global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True    # turn on/off 
file2output = None
count2skipped = 0
count2replaced = 0
count2total = 0
count2test4url = 0
count2ack4url  = 0
count2nack4url = 0 
                                                                                           
kb2search = {}
kb2replace = {}
kb2url  = {}
key2url = 0 

# -------------------------------------------------------------------------------------------------
# mandatory input to build kb2url
# -------------------------------------------------------------------------------------------------
kb2search [1]='.app'
kb2search [2]='.dev'
kb2search [3]='.com'
kb2search [4]='.org'



# -------------------------------------------------------------------------------------------------
# output files unmodified, kb2url built to be opened with browser
# ------------------------------------------------------------------------------------------------- 
kb2replace[1]='.app'
kb2replace[2]='.dev'
kb2replace[3]='.com'
kb2replace[4]='.org'


keys2search  = kb2search.keys()
keys2replace = kb2replace.keys()
keys2url     = kb2url.keys()


path2write4xi = None

path2read4xi  = VersionKB4Xi['input2verify4url']       # defines input folder to be walked with all its subfolders
path2write4xi = VersionKB4Xi['output2verify4url']      # defines input folder for output 

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi}
       
string2app  = ".app"
string2dev  = ".dev"
string2ssl  = "https:"
count2app  = 0
count2dev  = 0
count2ssl  = 0         

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = '.html'                      # object types to be fetched
                                             # '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C, 
                                             # '.html', 'xml'

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4replace" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 1A/33) OF SET2TRACE4REPLACE - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 1B/33) OF SET2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4REPLACE - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # APU2Buffer4Xi; APU2CommandQueue4Xi ... finish2commandqueue4bpu; finish2commandqueue4apu ...
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    if ack2debug is True:
        print('=' *33)
        print("(Step 33/33) OF SET2TRACE4REPLACE - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4replace" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 01A/33) of DENY2TRACE4REPLACE: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 01B/33) OF DENY2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4REPLACE - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4REPLACE - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4REPLACE - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4REPLACE - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4REPLACE *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4REPLACE - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4REPLACE - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    if ack2debug is True:
        print("(Step 033/33) OF SET2TRACE4REPLACE - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global ack2debug
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    if ack2debug is True:
        print("(Step 001A/33) OF TAILOR2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # 'Pipe4Xi': 'NACK4TRACE',
         # 'Queue4Xi': 'NACK4TRACE',         
         # 'Process4Xi': 'NACK4TRACE',
         'walk2count4url': 'NACK4TRACE' # turn on/off by deleting/setting comment on/off
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        if ack2debug is True:
            print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
            # Pipe4Xi, Process4Xi, Queue4Xi, walk2count4url

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    if ack2debug is True:
        print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
        #

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
    
    class2print  = "walk2count4url"
    method2print = "walk2count4url" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-walk2count4url.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2count4url.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2count4url.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing ofStudio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="yourDragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing walk2count4url.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">walk2count4url sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-walk2count4url.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2count4url.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2count4url.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for walk2count4url.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-walk2count4url.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2count4url.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2count4url.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for walk2count4url.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of walk2count4url.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "walk2count4url" usage = "
#   replaces defined targets from dragon4xi folders
#"> 
# -------------------------------------------------------------------------------------------------
def walk2count4url(target2explore):
    global ack2debug
    
    global count2skipped
    global count2replaced
    global count2total
    
    global count2test4url
    global count2ack4url
    global count2nack4url
    
    global count2app
    global count2dev
    global count2ssl
    
  
    global kb2replace                              # knowledgebase for replacing
    global keys2search

    global kb2search          
    global keys2replace
    
    global kb2url                                  # knowledgebase for url
    global keys2url
    global key2url
    
    global name2create   
    global path2read4xi                            # path for input source targets
    global path2write4xi                           # path for output source targets
    global profile2fetch                           # extension for files

    global t2xi
    global trace_object_count    
    
    class2print  = "walk2count4url"
    method2print = "walk2count4url" 
 
    message2print = "{(Step 0A/33) using" + "; t2xi-using-by-walk2count4url: " + str(t2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    message2print = "{(Step 1/8) got" + "; target2explore-got-by-walk2count4url: " + str(target2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # yourdragonxi_abstract.html 
               
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore)
    
    path2input = None    
    if name2target[1] == profile2fetch:
        # html
                  
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF WALK2COUNT4URL - TARGET ACCORDING TO PROFILE
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; target2explore-analyzing-by-walk2count4url: " + str(target2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # 
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF WALK2COUNT4URL - INPUT FILE PATH 
        # -----------------------------------------------------------------------------------------
        path2input = name2target[0] + profile2fetch 
        message2print = "{(Step 2A/33) set" + "; path2input-set-by-walk2count4url to: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF WALK2COUNT4URL - OPEN INPUT FILE
        # -----------------------------------------------------------------------------------------
        file2input = open(path2input,'r')
        message2print = "{(Step 3A/33) opened" + "; file2input-opened-by-walk2count4url: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # 
         
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF WALK2COUNT4URL - OUTPUT FILE NAME 
        # -----------------------------------------------------------------------------------------
        string2skip = '/'
        name2create = path2input
        max2try = 33
        count2try = 0
        while 1:
            index2skip = str.find(name2create,string2skip)
            count2try = count2try + 1
            if (index2skip == -1) or (count2try > max2try):
                break
            else:
                name2create = name2create[index2skip+1:]
                
        message2print = "{(Step 3B/33) set" + "; name2create to: " + str(name2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                
        # -----------------------------------------------------------------------------------------
        # (Step 4/33) OF WALK2COUNT4URL - OPEN OUTPUT FILE
        # -----------------------------------------------------------------------------------------
        path2output = path2write4xi + name2create
        
        message2print = "{(Step 4A/33) set" + "; path2output-set-by-walk2count4url to: " + str(path2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        #         
        
        file2output = open(path2output,'w') 
        message2print = "{(Step 4B/33) opened" + "; file2output-opened-by-walk2count4url: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        #  

        while 1:
            # -------------------------------------------------------------------------------------
            # (Step 5/33) OF WALK2COUNT4URL - PROCESS FILE
            # -------------------------------------------------------------------------------------             
            line2process = file2input.readline()  
            if not line2process:
                # ---------------------------------------------------------------------------------
                # (Step 5/33) OF WALK2COUNT4URL - ALL LINES READ, FINISH
                # ---------------------------------------------------------------------------------             
                break                                               
            else:
                # ---------------------------------------------------------------------------------
                # (Step 7/33) OF WALK2COUNT4URL - EXAMINE AND IF NEEDED, PROCESS LINE 
                # ---------------------------------------------------------------------------------
                line2write = line2process
                first2tell = True
                ack2replace = False
                for key in keys2search:
                    # -----------------------------------------------------------------------------
                    # check all strings to be replaced
                    # ----------------------------------------------------------------------------- 
                    string2search = kb2search[key]
                    len2search = len(string2search)
                    
                    string2update = kb2replace[key]
                    len2update = len(string2update)
                    
                    difference2len = len2update - len2search
                        
                    index2replace = str.find(line2write,string2search)
                    if (index2replace == -1):
                        pass
                    else:
                        ack2replace = True
                        if first2tell is True: 
                            message2print = "{(Step 7A/33) got" + "; line2process-got-by-walk2count4url: " + str(line2process) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # <b>&raquo;</b><a href="https://convolutionalneuralnetwork.app/" target="_blank">.app</a> 
                            first2tell = False
                            count2app = 0
                            count2dev = 0
                            count2ssl = 0
                              
                        message2print = "{(Step 7B/33) got" + "; string2search-got-by-walk2count4url: " + str(string2search) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # https:
                        
                        message2print = "{(Step 7C/33) got" + "; string2update-got-by-walk2count4url: " + str(string2update) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # https: 
                        
                        message2print = "{(Step 7D/33) set" + "; index2replace-set-by-walk2count4url to: " + str(index2replace) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 30
                        
                        message2print = "{(Step 7E/33) got" + "; begin2write-got-by-walk2count4url: " + str(line2write[0:index2replace]) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <b>&raquo;</b><a href="
                        
                                               
                        begin2write = line2write[0:index2replace] + string2update
                        
                        message2print = "{(Step 7F/33) set" + "; begin2write-set-by-walk2count4url to: " + str(begin2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <b>&raquo;</b><a href="https: 
                        
                        
                        index2next = index2replace + len2search                      
                        message2print = "{(Step 7G/33) set" + "; index2next-set-by-walk2count4url to: " + str(index2next) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 36
                        
                        line2write = begin2write + line2write[index2next:]
                        
                        message2print = "{(Step 7H/33) set" + "; line2write-set-by-walk2count4url to: " + str(line2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <b>&raquo;</b><a href="https://convolutionalneuralnetwork.app/" target="_blank">.app</a>
                        
                        
                        
                        # kb2url[ 0 ] =  https://convolutionalneuralnetwork.app
                        # kb2url[ 1 ] =  https://convolutionalneuralnetwork.dev
                        # kb2url[ 2 ] =  https://deeplearninginference.app
                        # kb2url[ 3 ] =  https://deeplearninginference.dev
                        # kb2url[ 4 ] =  https://www.knowledgereasoning.app
                        # kb2url[ 5 ] =  https://www.objectdetection.app
                        # ...
                        

                        
                        index2ssl = str.find(line2write,string2ssl)
                        if (index2ssl == -1):
                            message2print = "{(Step 7I/33) got" + "; line2write: " + str(line2write) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            #
                        else:     
                            index2app = str.find(line2write,string2app)
                            index2dev = str.find(line2write,string2dev)
                            if (index2app == -1):
                                pass
                            else:
                                if count2app == 0:
                                    kb2url [key2url]  = line2write [index2ssl:index2app+len(string2app)]
                                    key2url = key2url + 1
                                    count2app = count2app + 1
                                else:
                                    pass                                
                            if (index2dev == -1):
                                pass
                            else:
                                if count2dev == 0:
                                    kb2url [key2url]  = line2write [index2ssl:index2dev+len(string2dev)]
                                    key2url = key2url + 1
                                    count2dev = count2dev + 1
                                else:
                                    pass    

                                
                           
            # ---------------------------------------------------------------------------------
            # (Step 29/33) OF WALK2COUNT4URL - WRITE PROCESSED LINE
            # ---------------------------------------------------------------------------------                           
            if ack2replace is True:
                file2output.write(line2write)
            else:
                file2output.write(line2process)
    
                            
        # -----------------------------------------------------------------------------------------
        # (Step 31/33) OF WALK2COUNT4URL - CLOSE INPUT
        # -----------------------------------------------------------------------------------------            
        file2input.close()
        message2print = "{(Step 31A/33) closed" + "; file2input-closed-by-walk2count4url: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        # 
            
                        
        # -----------------------------------------------------------------------------------------
        # (Step 32/33) OF WALK2COUNT4URL - CLOSE OUTPUT
        # -----------------------------------------------------------------------------------------            
        file2output.close()
        message2print = "{(Step 31B/33) closed" + "; file2output-closed-by-walk2count4url: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
            
    else:
        message2print = "{(Step 1E/33) skipped" + "; path2input-skipped-by-walk2count4url: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # 
            
        count2skipped = count2skipped + 1
        count2total = count2total + 1
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2debug
    global count2app
    global count2dev
    global count2skipped
    global count2replaced
    global count2total
    global count2test4url
    global count2ack4url
    global count2nack4url
    
    global path2read4xi
    global path2write4xi
    global profile2fetch
    
    global kb2url
    global keys2url
    global key2url

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    if ack2debug is True:
        print("(Step 0A/33) OF MAIN WALK2COUNT4URL - SET T2XI TO: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
    
     
    count2skipped = 0
    count2replaced = 0
    count2total  = 0
    count2test4url  = 0
    count2ack4url  = 0
    count2nack4url  = 0   

    set2trace4replace()                                                                                               # trace all classes and functions in the system
    deny2trace4replace()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 0B/33) OF MAIN WALK2COUNT4URL - VERSION 4.4 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " STARTED ", time4xi())
    # 
    
    pipe2fetch = Pipe4Xi()
    if ack2debug is True:
        print("(Step 1A/33) OF MAIN WALK2COUNT4URL - PIPE2FETCH ", pipe2fetch)    
    
    queue2fetch = Queue4Xi()
    if ack2debug is True:
        print("(Step 1B/33) OF MAIN WALK2COUNT4URL - QUEUE2FETCH ", queue2fetch)    
    
        print("(Step 1C/33) OF MAIN WALK2COUNT4URL - PATH2READ4XI ", path2read4xi) 
    
        print("(Step 1D/33) OF MAIN WALK2COUNT4URL - PATH2WRITE4XI ", path2write4xi)
     
    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            print("(Step 2A/33) OF MAIN WALK2COUNT4URL - DIRECTORY: ", file2walk)
            # 
        if os.path.isfile(file2walk):
            walk2count4url(file2walk)
            
    # --------------------------------------------------------------------------------------------- 
    # 
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 3A/33) OF MAIN WALK2COUNT4URL - VERSION 4.4 - IN: ", path2read4xi, "- OUT: ", path2write4xi," - PROFILE: ", profile2fetch, " COMPLETED  ", time4xi())
      
    # ---------------------------------------------------------------------------------------------
    # Count .app and .dev  JATKAA
    # --------------------------------------------------------------------------------------------- 

    print("(Step 3D1/33) OF MAIN WALK2COUNT4URL - KB2URL CHECK")    
    for key2url in keys2url:

        try:
            text2search = kb2url [key2url]
            text2find = ".app" 
            index2url = str.find(text2search,text2find)
            if index2url == -1:
                pass
            else:
                count2app = count2app + 1 
            text2find = ".dev" 
            index2url = str.find(text2search,text2find)
            if index2url == -1:
                pass
            else:
                count2dev = count2dev + 1        

        except:
            print("** FAILED TO COUNT URL: ", kb2url [key2url])
     

    print("(Step 3D3/33) OF MAIN WALK2COUNT4URL - COUNT2APP: ", count2app)
    print("(Step 3D4/33) OF MAIN WALK2COUNT4URL - COUNT2DEV: ", count2dev)
    print("(Step 3D5/33) OF MAIN WALK2COUNT4URL - TOTAL URL: ", count2app + count2dev)
                   
    # ===========================================================================
    print('=' *75)
    
    
     
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    # print ('(Step 1E/33) OF MAIN WALK2COUNT4URL - PRINTING TRACE WITH T2XI', t2xi)
    # 
    # print_trace4xi(t2xi)        
    # print ('(Step 1F/33) OF MAIN WALK2COUNT4URL - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# 
# (Step 3A/33) OF MAIN WALK2COUNT4URL - VERSION 4.4 - IN:  G://temp//job2studio4xi//in//one2url4app// - OUT:  G://temp//job2studio4xi//out//one2url4app// 
#  - PROFILE:  .html  COMPLETED   11:16:29 09/03/19 FLE Daylight Time
# (Step 3D1/33) OF MAIN WALK2COUNT4URL - KB2URL CHECK
# (Step 3D3/33) OF MAIN WALK2COUNT4URL - COUNT2APP:  59
# (Step 3D4/33) OF MAIN WALK2COUNT4URL - COUNT2DEV:  46
# (Step 3D5/33) OF MAIN WALK2COUNT4URL - TOTAL URL:  105
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of walk2count4url.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

